import fs from "fs/promises";
import { Loader } from "./loader";
export class DataLoader extends Loader {
    constructor(data_path, data_key, transform) {
        super(transform);
        this.data_path = data_path;
        this.data_key = data_key;
        this.loadData();
    }
    async loadData() {
        try {
            const buffer = await fs.readFile(this.data_path);
            const obj = JSON.parse(buffer.toString());
            this.data = this.mapTransform(this.data_key ? obj[this.data_key] : obj);
        }
        catch (err) {
            this.data = [];
        }
    }
}
