import fetch from "node-fetch";
import { Loader } from "./loader";
export class OnlineLoader extends Loader {
    constructor(url, data_key, transform) {
        super(transform);
        this.url = url;
        this.data_key = data_key;
        this.loadData();
    }
    async loadData() {
        try {
            const res = await fetch(this.url);
            if (res.status >= 400)
                throw `Error ${res.status}`;
            const restxt = await res.text();
            const obj = JSON.parse(restxt);
            this.data = this.mapTransform(this.data_key ? obj[this.data_key] : obj);
        }
        catch (err) {
            // TODO Log error
        }
    }
}
